package de.ozgcloud.vorgang.common.migration;

import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;

import io.mongock.api.annotations.ChangeUnit;
import io.mongock.api.annotations.Execution;
import io.mongock.api.annotations.RollbackExecution;

@ChangeUnit(id = "2024-07-29 17:30:00 OZG-6259", order = "M011", author = "mkuester", runAlways = true)
public class M011_SetDefaultCollaborationLevel { // NOSONAR

	private static final String VORGANG_COLLECTION = "vorgang";

	static final String HEADER_FIELD = "header";
	static final String COLLABORATION_LEVEL_FIELD = "collaborationLevel";
	static final String HEADER_COLLABORATION_LEVEL_FIELD = HEADER_FIELD + "." + COLLABORATION_LEVEL_FIELD;
	private static final int DEFAULT_COLLABORATION_LEVEL = 0;

	@Execution
	public void doMigration(MongoTemplate template) {
		template.updateMulti(createFilterQuery(), createUpdate(), VORGANG_COLLECTION);
	}

	private Query createFilterQuery() {
		return new Query(Criteria.where(HEADER_COLLABORATION_LEVEL_FIELD).exists(false));
	}

	private Update createUpdate() {
		return new Update().set(HEADER_COLLABORATION_LEVEL_FIELD, DEFAULT_COLLABORATION_LEVEL);
	}

	@RollbackExecution
	public void rollback() {
		// kein rollback implementiert
	}
}