package de.ozgcloud.vorgang.servicekonto;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mapstruct.factory.Mappers;
import org.mockito.InjectMocks;
import org.mockito.Spy;

import de.ozgcloud.vorgang.common.grpc.GrpcObjectMapper;
import de.ozgcloud.vorgang.vorgang.GrpcServiceKonto;

class ServiceKontoMapperTest {

	@InjectMocks
	private ServiceKontoMapper mapper = Mappers.getMapper(ServiceKontoMapper.class);
	@Spy
	private GrpcObjectMapper grpcObjectMapper = Mappers.getMapper(GrpcObjectMapper.class);

	@DisplayName("From serviceKonto")
	@Nested
	class TestFromServiceKonto {

		@Test
		void shouldMapFields() {
			var serviceKonto = fromServiceKonto();

			assertThat(serviceKonto).usingRecursiveComparison().isEqualTo(ServiceKontoTestFactory.create());
		}

		private ServiceKonto fromServiceKonto() {
			return mapper.fromServiceKonto(GrpcServiceKontoTestFactory.create());
		}
	}

	@DisplayName("to serviceKonto")
	@Nested
	class TestToServiceKonto {

		@Test
		void shouldMapFields() {
			var serviceKonto = toServiceKonto();

			assertThat(serviceKonto).usingRecursiveComparison().isEqualTo(GrpcServiceKontoTestFactory.create());
		}

		private GrpcServiceKonto toServiceKonto() {
			return mapper.toServiceKonto(ServiceKontoTestFactory.create());
		}
	}
}